image: registry.gitlab.com/peachtech/docker-compose:20.10

stages:
    - lint
    - build
    - test
    - deploy
    - security

variables:
    # Sample variables as reference:
    # CI_REGISTRY_IMAGE="registry.gitlab.com/gitlab-org/security-products/api-security-targets/image-target-flask"
    # CI_COMMIT_REF_SLUG=main
    # CI_COMMIT_SHA=dd648b2e48ce6518303b0bb580b2ee32fadaf045
    # CI_COMMIT_SHORT_SHA=dd648b2e
    # TARGET_IMAGE_ID: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
    TARGET_IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:latest

# #################################################

linting:
    stage: lint
    needs: []
    services:
        - docker:20.10-dind
    script:
        - ./build/jobs/linting

# #################################################

build_image:
    stage: build
    needs: []
    services:
        - docker:20.10-dind
    cache:
        key: $CI_COMMIT_SHORT_SHA-image
        paths:
            - output/flask_rest_target.tar
        policy: push
    script:
        - ./build/jobs/build_image

# #################################################

tests_unit_flask:
    services:
        - docker:20.10-dind
    stage: test
    needs: ["build_image"]
    script:
        - ./build/jobs/tests_unit_flask
    cache:
        key: $CI_COMMIT_SHORT_SHA-image
        paths:
            - output/flask_rest_target.tar
        policy: pull
    artifacts:
        when: always
        paths:
            - ./gl-*.log
            - output/*.xml
        reports:
            junit:
                - output/junit_*.xml

# #################################################

deploy_image:
    stage: deploy
    needs: ["linting", "tests_unit_flask"]
    services:
        - docker:20.10-dind
    cache:
        key: $CI_COMMIT_SHORT_SHA-image
        paths:
            - output/flask_rest_target.tar
        policy: pull
    script:
        - ./build/jobs/deploy_image

# #################################################

scan_dependencies:
    stage: security
    needs: ["build_image"]
    allow_failure: true
    services:
        - docker:20.10-dind
    cache:
        key: $CI_COMMIT_SHORT_SHA-image
        paths:
            - output/flask_rest_target.tar
        policy: pull
    script:
        - ./build/jobs/scan_dependencies
# #################################################

# # end

